* version 1.1, 6/7/01: adds "if" option and "missing" option
capture program drop hilo
program define hilo
  version 6.0
  syntax varlist [if] , [ Show(integer 10) Low High Missing]

  tokenize `varlist'
  local first `1'
  macro shift
  local rest `*'
  preserve

  * if "if" is missing, make it 1, all are kept
  if "`if'"=="" {
    local if "if 1"
  }

  * mnm 6/7/01, support use of "if" and "missing"
  if "`missing'"=="" {
    quietly keep `if' & `first' != .
  }
  else {
    quietly keep `if' 
  }

  sort `first'
  if "`high'"=="" & "`low'"=="" {
    local high = "high"
    local low = "low"
  }
  if "`high'"!="" & "`low'"!="" {
    display in green "`show' lowest and highest observations on `first'"
  }
  if "`high'"!="" & "`low'"=="" {
    display in green "`show' highest observations on `first'"
  }
  if "`high'"=="" & "`low'"!="" {
    display in green "`show' lowest observations on `first'"
  }

  if "`low'"!="" {
    list `first' `rest' in 1/`show', noobs
  }
  if "`high'"!="" {
    list `first' `rest' in -`show'/l, noobs
  }
end
